#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "os2.h"

/* Old version - deprecated (can't handle missing fields)
char * lprtok (char *string,char *control)
{
        unsigned char *str;
        const unsigned char *ctrl = control;

        unsigned char map[32];
        int count;

        static char *nextoken;

        for (count = 0; count < 32; count++)
                map[count] = 0;

        do {
                map[*ctrl >> 3] |= (1 << (*ctrl & 7));
        } while (*ctrl++);

        if (string)
                str = string;
        else
                str = nextoken;

        while ( (map[*str >> 3] & (1 << (*str & 7))) && *str )
                str++;

        string = str;

        for ( ; *str ; str++ )
                if ( map[*str >> 3] & (1 << (*str & 7)) ) {
                        *str++ = '\0';
                        break;
                }

        nextoken = str;

        if ( string == str )
                return NULL;
        else
                return string;
}
*/

/* New version that can handle missing fields */
char * lprtok (char *string,char *control)
{
    char *c;
    static char *next;

    if ( control == NULL ) return string;
    if ( string  == NULL ) string = next;
    if ( string  == NULL ) return NULL;

    if (( c = strpbrk( string, control )) == NULL ) {
        next = NULL;
    }
    else {
        next = c+1;
        *c = '\0';
    }

    return ( string );
}


int main(int argc,char **argv)
{
  PUCHAR token;
  UCHAR szTemp[80];
  USHORT i;

  strcpy(szTemp,":param1:param2::param3:");
  token = lprtok(szTemp,":");
  while (token != NULL)
    {
      printf("Token: %s\n\r",token);
      token = lprtok(NULL,":");
    }
  return 0;
}
